/*********************************************************************
 *
 *  $Id: svn_id $
 *
 *  Implements YSoundSpectrumProxy, the Proxy API for SoundSpectrum
 *
 *  - - - - - - - - - License information: - - - - - - - - -
 *
 *  Copyright (C) 2011 and beyond by Yoctopuce Sarl, Switzerland.
 *
 *  Yoctopuce Sarl (hereafter Licensor) grants to you a perpetual
 *  non-exclusive license to use, modify, copy and integrate this
 *  file into your software for the sole purpose of interfacing
 *  with Yoctopuce products.
 *
 *  You may reproduce and distribute copies of this file in
 *  source or object form, as long as the sole purpose of this
 *  code is to interface with Yoctopuce products. You must retain
 *  this notice in the distributed source file.
 *
 *  You should refer to Yoctopuce General Terms and Conditions
 *  for additional information regarding your rights and
 *  obligations.
 *
 *  THE SOFTWARE AND DOCUMENTATION ARE PROVIDED 'AS IS' WITHOUT
 *  WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
 *  WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS
 *  FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO
 *  EVENT SHALL LICENSOR BE LIABLE FOR ANY INCIDENTAL, SPECIAL,
 *  INDIRECT OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
 *  COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR
 *  SERVICES, ANY CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT
 *  LIMITED TO ANY DEFENSE THEREOF), ANY CLAIMS FOR INDEMNITY OR
 *  CONTRIBUTION, OR OTHER SIMILAR COSTS, WHETHER ASSERTED ON THE
 *  BASIS OF CONTRACT, TORT (INCLUDING NEGLIGENCE), BREACH OF
 *  WARRANTY, OR OTHERWISE.
 *
 *********************************************************************/


using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using System.Timers;
using System.Globalization;
using System.Text.RegularExpressions;
using YoctoLib;

namespace YoctoProxyAPI
{
    //--- (YSoundSpectrum class start)
    static public partial class YoctoProxyManager
    {
        public static YSoundSpectrumProxy FindSoundSpectrum(string name)
        {
            // cases to handle:
            // name =""  no matching unknwn
            // name =""  unknown exists
            // name != "" no  matching unknown
            // name !="" unknown exists
            YSoundSpectrum func = null;
            YSoundSpectrumProxy res = (YSoundSpectrumProxy)YFunctionProxy.FindSimilarUnknownFunction("YSoundSpectrumProxy");

            if (name == "") {
                if (res != null) return res;
                res = (YSoundSpectrumProxy)YFunctionProxy.FindSimilarKnownFunction("YSoundSpectrumProxy");
                if (res != null) return res;
                func = YSoundSpectrum.FirstSoundSpectrum();
                if (func != null) {
                    name = func.get_hardwareId();
                    if (func.get_userData() != null) {
                        return (YSoundSpectrumProxy)func.get_userData();
                    }
                }
            } else {
                func = YSoundSpectrum.FindSoundSpectrum(name);
                if (func.get_userData() != null) {
                    return (YSoundSpectrumProxy)func.get_userData();
                }
            }
            if (res == null) {
                res = new YSoundSpectrumProxy(func, name);
            }
            if (func != null) {
                res.linkToHardware(name);
                if(func.isOnline()) res.arrival();
            }
            return res;
        }
    }

/**
 * <summary>
 *   The <c>YSoundSpectrum</c> class allows you to read and configure Yoctopuce sound spectrum analyzers.
 * <para>
 *   It inherits from <c>YSensor</c> class the core functions to read measurements,
 *   to register callback functions, and to access the autonomous datalogger.
 * </para>
 * <para>
 * </para>
 * </summary>
 */
    public class YSoundSpectrumProxy : YFunctionProxy
    {
        /**
         * <summary>
         *   Retrieves a sound spectrum analyzer for a given identifier.
         * <para>
         *   The identifier can be specified using several formats:
         * </para>
         * <para>
         * </para>
         * <para>
         *   - FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionLogicalName
         * </para>
         * <para>
         * </para>
         * <para>
         *   This function does not require that the sound spectrum analyzer is online at the time
         *   it is invoked. The returned object is nevertheless valid.
         *   Use the method <c>YSoundSpectrum.isOnline()</c> to test if the sound spectrum analyzer is
         *   indeed online at a given time. In case of ambiguity when looking for
         *   a sound spectrum analyzer by logical name, no error is notified: the first instance
         *   found is returned. The search is performed first by hardware name,
         *   then by logical name.
         * </para>
         * <para>
         *   If a call to this object's is_online() method returns FALSE although
         *   you are certain that the matching device is plugged, make sure that you did
         *   call registerHub() at application initialization time.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="func">
         *   a string that uniquely characterizes the sound spectrum analyzer, for instance
         *   <c>MyDevice.soundSpectrum</c>.
         * </param>
         * <returns>
         *   a <c>YSoundSpectrum</c> object allowing you to drive the sound spectrum analyzer.
         * </returns>
         */
        public static YSoundSpectrumProxy FindSoundSpectrum(string func)
        {
            return YoctoProxyManager.FindSoundSpectrum(func);
        }
        //--- (end of YSoundSpectrum class start)
        //--- (YSoundSpectrum definitions)
        public const int _IntegrationTime_INVALID = -1;
        public const string _SpectrumData_INVALID = YAPI.INVALID_STRING;

        // reference to real YoctoAPI object
        protected new YSoundSpectrum _func;
        // property cache
        protected int _integrationTime = _IntegrationTime_INVALID;
        //--- (end of YSoundSpectrum definitions)

        //--- (YSoundSpectrum implementation)
        internal YSoundSpectrumProxy(YSoundSpectrum hwd, string instantiationName) : base(hwd, instantiationName)
        {
            InternalStuff.log("SoundSpectrum " + instantiationName + " instantiation");
            base_init(hwd, instantiationName);
        }

        // perform the initial setup that may be done without a YoctoAPI object (hwd can be null)
        internal override void base_init(YFunction hwd, string instantiationName)
        {
            _func = (YSoundSpectrum) hwd;
           	base.base_init(hwd, instantiationName);
        }

        // link the instance to a real YoctoAPI object
        internal override void linkToHardware(string hwdName)
        {
            YSoundSpectrum hwd = YSoundSpectrum.FindSoundSpectrum(hwdName);
            // first redo base_init to update all _func pointers
            base_init(hwd, hwdName);
            // then setup Yocto-API pointers and callbacks
            init(hwd);
        }

        // perform the 2nd stage setup that requires YoctoAPI object
        protected void init(YSoundSpectrum hwd)
        {
            if (hwd == null) return;
            base.init(hwd);
            InternalStuff.log("registering SoundSpectrum callback");
            _func.registerValueCallback(valueChangeCallback);
        }

        /**
         * <summary>
         *   Returns an array of strings representing hardware identifiers for all SoundSpectrum functions presently connected.
         * <para>
         * </para>
         * </summary>
         */
        public static new string[] GetSimilarFunctions()
        {
            List<string> res = new List<string>();
            YSoundSpectrum it = YSoundSpectrum.FirstSoundSpectrum();
            while (it != null)
            {
                res.Add(it.get_hardwareId());
                it = it.nextSoundSpectrum();
            }
            return res.ToArray();
        }

        protected override void functionArrival()
        {
            base.functionArrival();
        }

        protected override void moduleConfigHasChanged()
       	{
            base.moduleConfigHasChanged();
            _integrationTime = _func.get_integrationTime();
        }

        /**
         * <summary>
         *   Returns the integration time in milliseconds for calculating time
         *   weighted spectrum data.
         * <para>
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   an integer corresponding to the integration time in milliseconds for calculating time
         *   weighted spectrum data
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YSoundSpectrum.INTEGRATIONTIME_INVALID</c>.
         * </para>
         */
        public int get_integrationTime()
        {
            int res;
            if (_func == null) {
                throw new YoctoApiProxyException("No SoundSpectrum connected");
            }
            res = _func.get_integrationTime();
            if (res == YAPI.INVALID_INT) {
                res = _IntegrationTime_INVALID;
            }
            return res;
        }

        /**
         * <summary>
         *   Changes the integration time in milliseconds for computing time weighted
         *   spectrum data.
         * <para>
         *   Be aware that on some devices, changing the integration
         *   time for time-weighted spectrum data may also affect the integration
         *   period for one or more sound pressure level measurements.
         *   Remember to call the <c>saveToFlash()</c> method of the
         *   module if the modification must be kept.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="newval">
         *   an integer corresponding to the integration time in milliseconds for computing time weighted
         *   spectrum data
         * </param>
         * <para>
         * </para>
         * <returns>
         *   <c>0</c> if the call succeeds.
         * </returns>
         * <para>
         *   On failure, throws an exception or returns a negative error code.
         * </para>
         */
        public int set_integrationTime(int newval)
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No SoundSpectrum connected");
            }
            if (newval == _IntegrationTime_INVALID) {
                return YAPI.SUCCESS;
            }
            return _func.set_integrationTime(newval);
        }

        // property with cached value for instant access (configuration)
        /// <value>Integration time in milliseconds for calculating time</value>
        public int IntegrationTime
        {
            get
            {
                if (_func == null) {
                    return _IntegrationTime_INVALID;
                }
                if (_online) {
                    return _integrationTime;
                }
                return _IntegrationTime_INVALID;
            }
            set
            {
                setprop_integrationTime(value);
            }
        }

        // private helper for magic property
        private void setprop_integrationTime(int newval)
        {
            if (_func == null) {
                return;
            }
            if (!(_online)) {
                return;
            }
            if (newval == _IntegrationTime_INVALID) {
                return;
            }
            if (newval == _integrationTime) {
                return;
            }
            _func.set_integrationTime(newval);
            _integrationTime = newval;
        }
    }
    //--- (end of YSoundSpectrum implementation)
}

